"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.controllerTemplate = void 0;
const controllerTemplate = ({ requestTypeName, responseTypeName, controllerTypeName, controllerMethodName, pathParamsType = 'ParamsDictionary', responseBodyType, bodyParamType, queryParamsType = 'ParsedQs', statusCodeType = 'number' }) => {
    return `
    export type ${requestTypeName} = Request<
      ${pathParamsType},
      ${responseBodyType},
      ${bodyParamType},
      ${queryParamsType},
      Record<string, any>
    >;

    export type ${responseTypeName} = Response<
      ${responseBodyType},
      Record<string, any>,
      ${statusCodeType}
    >;

    export abstract class ${controllerTypeName} {
      abstract ${controllerMethodName}(
        req: ${requestTypeName},
        res: ${responseTypeName},
        next: NextFunction
      ): Promise<unknown | void>;
    }`;
};
exports.controllerTemplate = controllerTemplate;
