"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
require("ts-array-extensions");
const cli_logging_1 = require("../../lib/cli-logging");
const handlers_1 = require("./handlers");
const TypeDefContext_1 = require("../../helpers/open-api/TypeDefContext");
const generate = ({ logger, openApiDocument, nonRequiredType, readonlyDTOs, emptyType }) => {
    const log = logger?.create('Generating');
    const context = new TypeDefContext_1.TypeDefContext();
    const controllers = (0, handlers_1.generateHandlers)(openApiDocument, { nonRequiredType, readonlyDTOs, emptyType }, context, log);
    const code = `
    import type { Request, Response, Express, NextFunction, ParamsDictionary, ErrorRequestHandler } from 'express-serve-static-core';
    import { Router } from 'express';
    import { ParsedQs } from 'qs';
    import * as ExpressJonValidator from 'express-json-validator-middleware';
    
    ${context.generateCode()}

    ${controllers}
  `;
    log?.((0, cli_logging_1.success)());
    return code;
};
exports.generate = generate;
