"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handlerTemplate = void 0;
const handlerTemplate = ({ requestTypeName, responseTypeName, handlerTypeName, pathParamsType = 'ParamsDictionary', responseBodyType, bodyParamType, queryParamsType = 'ParsedQs', statusCodeType = 'number' }) => {
    return `
    export type ${requestTypeName} = Request<
      ${pathParamsType},
      ${responseBodyType},
      ${bodyParamType},
      ${queryParamsType},
      Record<string, any>
    >;

    export type ${responseTypeName} = Response<
      ${responseBodyType},
      Record<string, any>,
      ${statusCodeType}
    >;

    export type ${handlerTypeName} = (
      req: ${requestTypeName},
      res: ${responseTypeName},
      next: NextFunction
    ) => Promise<void> | void;
     
  `;
};
exports.handlerTemplate = handlerTemplate;
