"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
require("ts-array-extensions");
const cli_logging_1 = require("../../lib/cli-logging");
const methods_1 = require("./methods");
const TypeDefContext_1 = require("../../helpers/open-api/TypeDefContext");
const generate = ({ logger, openApiDocument, nonRequiredType, readonlyDTOs, emptyType }) => {
    const log = logger?.create('Generating types');
    const context = new TypeDefContext_1.TypeDefContext();
    const handlers = (0, methods_1.generateMethods)(openApiDocument, { nonRequiredType, readonlyDTOs, emptyType }, context, log);
    const code = `
    import * as msw from 'msw';

    ${context.generateCode()}

    ${handlers.join('\n')}
  `;
    log?.((0, cli_logging_1.success)());
    return code;
};
exports.generate = generate;
