"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonWalker = void 0;
const pointerSub_1 = require("./pointerSub");
class JsonWalker {
    static walkArray(obj, itemCallback, ptr) {
        obj.forEach((item, index) => {
            JsonWalker.walk(item, itemCallback, (0, pointerSub_1.pointerSub)(ptr ?? '', index));
        });
    }
    static walkMap(obj, itemCallback, ptr) {
        Object.entries(obj).forEach(([key, item]) => {
            JsonWalker.walk(item, itemCallback, (0, pointerSub_1.pointerSub)(ptr ?? '', key));
        });
    }
    static walk(obj, itemCallback, ptr) {
        if (typeof obj === 'object' && obj !== null) {
            if (Array.isArray(obj)) {
                JsonWalker.walkArray(obj, itemCallback, ptr);
            }
            else {
                itemCallback(obj, ptr ?? '');
                JsonWalker.walkMap(obj, itemCallback, ptr);
            }
        }
    }
}
exports.JsonWalker = JsonWalker;
