"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncJsonWalker = void 0;
const pointerSub_1 = require("../pointerSub");
class AsyncJsonWalker {
    static async walkArray(obj, itemCallback, ptr) {
        await obj.forEachAsync((item, index) => AsyncJsonWalker.walk(item, itemCallback, (0, pointerSub_1.pointerSub)(ptr ?? '', index)));
    }
    static async walkMap(obj, itemCallback, ptr) {
        await Object.entries(obj).forEachAsync(async ([key, item]) => AsyncJsonWalker.walk(item, itemCallback, (0, pointerSub_1.pointerSub)(ptr ?? '', key)));
    }
    static async walk(obj, itemCallback, ptr) {
        if (typeof obj === 'object' && obj !== null) {
            if (Array.isArray(obj)) {
                await AsyncJsonWalker.walkArray(obj, itemCallback, ptr);
            }
            else {
                await itemCallback(obj, ptr ?? '');
                await AsyncJsonWalker.walkMap(obj, itemCallback, ptr);
            }
        }
    }
}
exports.AsyncJsonWalker = AsyncJsonWalker;
