"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inferOperationId = void 0;
const initUpper_1 = require("./initUpper");
const inferOperationId = (method, path) => {
    const varsRegex = /\{.*?\}/gm;
    const vars = path
        .match(varsRegex)
        ?.map(m => m.substring(1, m.length - 1))
        .map(initUpper_1.initUpper);
    const suffix = vars?.any() ? `By${vars.join('And')}` : '';
    const remainingPath = path
        .replace(varsRegex, '')
        .replace(/\/|-|_/g, ' ')
        .split(' ')
        .map(initUpper_1.initUpper)
        .join('');
    return `${method}${remainingPath}${suffix}`;
};
exports.inferOperationId = inferOperationId;
