"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeDefContext = void 0;
class TypeDefContext {
    typeIndex = [];
    types = {};
    emitType(name, definition) {
        this.types[name] = definition;
    }
    shouldEmitType(name) {
        return !this.typeIndex.includes(name);
    }
    willEmitType(name) {
        this.typeIndex.push(name);
    }
    generateCode() {
        return Object.entries(this.types)
            .map(([name, def]) => `export type ${name} = ${def};`)
            .join('\n\n');
    }
}
exports.TypeDefContext = TypeDefContext;
