"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dereference = void 0;
const dereference = (references, $ref, prefix) => {
    if (!$ref.startsWith(prefix)) {
        throw new Error(`Invalid $ref ${$ref}`);
    }
    const name = $ref.substring($ref.lastIndexOf('/') + 1);
    const maybe = references?.[name];
    if (!maybe)
        throw new Error(`Failed to deference ${$ref}`);
    return maybe;
};
exports.dereference = dereference;
