"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dereference = void 0;
const json_pointer_1 = __importDefault(require("json-pointer"));
// eslint-disable-next-line @typescript-eslint/no-unnecessary-type-parameters
const dereference = (document, $ref) => {
    let current = {
        $ref
    };
    while (current && '$ref' in current) {
        const pointer = current.$ref.split('#')[1];
        current = json_pointer_1.default.get(document, pointer);
    }
    if (!current)
        throw new Error(`Failed to deference ${$ref}`);
    return current;
};
exports.dereference = dereference;
