"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSecurityParams = void 0;
const dereferenceSecurityScheme_1 = require("./dereferenceSecurityScheme");
const getSecurityParams = (document, location) => {
    if (!location.security) {
        return [];
    }
    return location.security.flatMap(s => Object.keys(s).compactMap(key => {
        const scheme = (0, dereferenceSecurityScheme_1.dereferenceSecurityScheme)({ $ref: `#/components/securitySchemes/${key}` }, document);
        if (scheme.type === 'http') {
            return {
                name: 'authorization',
                in: 'header'
            };
        }
        if (scheme.type === 'apiKey') {
            if (scheme.in === 'cookie') {
                return {
                    name: scheme.name,
                    in: scheme.in
                };
            }
        }
        return undefined;
    }));
};
exports.getSecurityParams = getSecurityParams;
