"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeDefForEnum = void 0;
const typeDefForEnum = (members) => {
    return members
        .map(e => {
        if (typeof e === 'string') {
            return `"${e}"`;
        }
        if (e === null) {
            return 'null';
        }
        if (typeof e === 'number') {
            return String(e);
        }
        if (typeof e === 'boolean') {
            return e ? 'true' : 'false';
        }
        if (typeof e === 'object') {
            return JSON.stringify(e);
        }
        throw new Error(`Unexpected enum member`);
    })
        .join(' | ');
};
exports.typeDefForEnum = typeDefForEnum;
