"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeDefForObject = void 0;
const templates_1 = require("../../../templates");
const typeDefForObject = (objectSchema, document, recursiveLookup, options, context) => {
    const { required, properties } = objectSchema;
    if (!properties)
        return options.emptyType;
    const requiredProperties = Array.isArray(required) ? required : [];
    const propertyList = Object.keys(properties).compactMap(propertyName => {
        if (typeof propertyName !== 'string') {
            return undefined;
        }
        const propertyObject = properties[propertyName];
        const isRequired = requiredProperties.includes(propertyName);
        const propertyType = recursiveLookup(propertyObject, document, options, context);
        return (0, templates_1.fieldTemplate)(propertyName, isRequired, propertyType, options);
    });
    return `{ ${propertyList.join('; ')} }`;
};
exports.typeDefForObject = typeDefForObject;
