"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processLogger = exports.progress = exports.warn = exports.success = void 0;
const chalk_1 = __importDefault(require("chalk"));
const readline_1 = __importDefault(require("readline"));
const o = process.stdout;
const e = process.stdout;
const progressLogger = (start) => {
    let last = 0;
    return m => {
        readline_1.default.cursorTo(o, start);
        o.write(m);
        if (m.length < last) {
            o.write(' '.repeat(last - m.length));
        }
        last = m.length;
    };
};
const success = () => chalk_1.default.green(' -> SUCCESS');
exports.success = success;
const warn = (message) => chalk_1.default.yellow(` -> WARNING: ${message}`);
exports.warn = warn;
const progress = (message) => chalk_1.default.blue(` -> ${message}`);
exports.progress = progress;
const processLogger = () => {
    const log = m => {
        o.write(`\n${m}`);
    };
    return {
        error: m => {
            e.write(`\n${chalk_1.default.red(m)}`);
        },
        log,
        create: m => {
            log(m);
            const l = progressLogger(m.length);
            l((0, exports.progress)('...'));
            return l;
        }
    };
};
exports.processLogger = processLogger;
