"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fieldTemplate = void 0;
const fieldTemplate = (name, required, type, options) => {
    const fieldName = `"${name}"`;
    const { nonRequiredType, readonlyDTOs } = options;
    const accessModifier = readonlyDTOs ? 'readonly ' : '';
    if (required) {
        return `${accessModifier}${fieldName}: ${type}`;
    }
    const fieldNameWithOptional = ['optional', 'both'].includes(nonRequiredType)
        ? `${fieldName}?`
        : fieldName;
    const typeWithNull = ['nullable', 'both'].includes(nonRequiredType)
        ? `${type} | null`
        : type;
    return `${accessModifier}${fieldNameWithOptional}: ${typeWithNull}`;
};
exports.fieldTemplate = fieldTemplate;
